#include "SliceCounter.hh"

SliceCounter::SliceCounter() : RequestManager("SliceCounter")
{
  m_log.debugL("Contructed SliceCounter");
  m_log.setMessageLevel(MESSAGE_LEVEL_DEBUG_MEDIUM);

  m_gcount = 0;
  m_ucount = 0;
}

SliceCounter::~SliceCounter()
{
  m_log.debugL("Destructed SliceCounter");
}

void SliceCounter::addSlice(SliceData * slice)
{
  RequestManager::addSlice(slice);
  char consensus = slice->getConsensus();
  m_gcount++;

  if (consensus != '-') { m_ucount++; }
  delete slice;
}

int SliceCounter::printResults()
{
  m_out << m_gcount << '\t' << m_ucount << endl;
  return m_errorCount;
}

void SliceCounter::handleOptions(Foundation * tf)
{
  //tf->getOptions()->addOptionResult("sgindex|y=i", &m_newSliceRangeGindex,
  //                                  "Set a new SliceRange Gindex");

  RequestManager::handleOptions(tf);
}
