#ifndef STRX_HH
#define STRX_HH 1

#if XERCES_VERSION_MINOR >= 5
using namespace XERCES_CPP_NAMESPACE;
#endif

// ---------------------------------------------------------------------------
//  This is a simple class that lets us do easy (though not terribly efficient)
//  trancoding of XMLCh data to local code page for display.
// ---------------------------------------------------------------------------
class StrX
{
public :
  StrX(const XMLCh* const toTranscode)
  {
    // Call the private transcoding method
    m_localForm = XMLString::transcode(toTranscode);
  }

  ~StrX()
  {
    delete [] m_localForm;
  }

  const char* localForm() const
  {
    return m_localForm;
  }

private :
  // This is the local code page form of the string.
  char * m_localForm;
};

inline ostream& operator<<(ostream& target, const StrX& toDump)
{
  target << toDump.localForm();
  return target;
}

#endif

