#ifndef TILINGMANAGER_HH
#define TILINGMANAGER_HH 1

#include "SequenceData.hh"
#include "ConsensusSequence.hh"
#include "RequestManager.hh"

using libSlice::SliceData;

class TilingManager : public RequestManager
{
public:
  TilingManager();
  ~TilingManager();

  void addSliceRange(long & index, long & gindex);
  void addSlice(SliceData * slice);

  int  printResults();

  void setAsmblId     (const string & asmbl_id);
  void setUser        (const string & user);
  void setComment     (const string & comment);
  void setMethod      (const string & method);
  void setCAId        (const string & caId);

  static void handleOptions(Foundation * tf);

private:
  static void loadConfig(ConfigFile * configFile);
  static void printConfig();

  ConsensusSequence * m_consensusSequence;

  int m_contigCount;

  static string m_asmblId;
  static string m_caId;
  static string m_user;
  static string m_comment;
  static string m_method;
  static string m_mod_date;
  static int m_doQuality;
};

#endif
